//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// *** SPFD5408 change -- Begin
#include <SPFD5408_Adafruit_GFX.h>    // Core graphics library
#include <SPFD5408_Adafruit_TFTLCD.h> // Hardware-specific library
#include <SPFD5408_TouchScreen.h>
// *** SPFD5408 change -- End
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#if defined(__SAM3X8E__)
#undef __FlashStringHelper::F(string_literal)
#define F(string_literal) string_literal
#endif



#define YP A1  // must be an analog pin, use "An" notation!
#define XM A2  // must be an analog pin, use "An" notation!
#define YM 7   // can be a digital pin
#define XP 6   // can be a digital pin

// Original values
/*
  #define TS_MINX 150
  #define TS_MINY 120
  #define TS_MAXX 920
  #define TS_MAXY 940
*/
// Calibrate values

#define TS_MINX 137
#define TS_MINY 76
#define TS_MAXX 948
#define TS_MAXY 890

// For better pressure precision, we need to know the resistance
// between X+ and X- Use any multimeter to read it
// For the one we're using, its 300 ohms across the X plate
TouchScreen ts = TouchScreen(XP, YP, XM, YM, 351);

#define LCD_CS A3
#define LCD_CD A2
#define LCD_WR A1
#define LCD_RD A0
// optional
#define LCD_RESET A4

// Assign human-readable names to some common 16-bit color values:
#define  BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE  0xFFFF
#define DARKGREY 0x7BEF
#define DIMGREY 0x6B4D
#define LIGHTGREY 0xD69A
#define SALMON 0xFC0E
#define DARKSEAGREEN 0x8DF1
#define LAWNGREEN 0x7FE0
#define DARKCYAN 0x0451
#define ORANGE 0xFD20
#define DEEPSKYBLUE 0x05FF
#define DODGERBLUE 0x1C9F
#define MIDNIGHTBLUE 0x18CE
#define DARKSLATEBLUE 0x49F1
#define CADETBLUE 0x5CF4

Adafruit_TFTLCD tft(LCD_CS, LCD_CD, LCD_WR, LCD_RD, LCD_RESET);

//#define BOXSIZE 48
#define MINPRESSURE 5
#define MAXPRESSURE 1000

int kerzenzahlen;
int poskerzex;
int poskerzey;
int xschreiben;
int yschreiben;
int Flammen[120];
int input;
int xzaehlen;
int yzaehlen;
int nachmalzahlen;
int zahl = 0;
int blasen;
const int microfon = A8;


void setup() {
  tft.reset();
  tft.begin(0x9341); // SDFP5408
  tft.setRotation(0); // Need for the Mega, please changed for your choice or rotation initial
  tft.fillScreen (BLACK);
  // tft.setTextSize(2);
  //currentcolor = RED;
  pinMode(13, OUTPUT);
  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////Kerzen Malen//////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  kerzendef();
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void loop() {
  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  
flackern();


    
  blasen = analogRead(microfon);
  kerzenzahlen =1;
  ausblasen();
  
}

void ausblasen(){
  while (blasen > 600) {

    xzaehlen = -2;
    yzaehlen = -1;
    while (kerzenzahlen < 51) {
      xzaehlen = xzaehlen + 2;
      yzaehlen = yzaehlen + 2;
      poskerzex = Flammen[xzaehlen];
      poskerzey = Flammen[yzaehlen];
      tft.fillCircle(poskerzex + 1, poskerzey - 4, 3, BLACK);
      tft.fillCircle(poskerzex + 1, poskerzey - 9, 2, BLACK);
       tft.fillRoundRect(poskerzex-3, poskerzey-11, 6, 10,2,BLACK);
   tft.fillRoundRect(poskerzex-2, poskerzey-11, 6, 10,2,BLACK);
      kerzenzahlen = kerzenzahlen + 1;
      nachmalzahlen = 1;
    }
    xzaehlen = -2;
    yzaehlen = -1;
    while (nachmalzahlen < 51) {
      xzaehlen = xzaehlen + 2;
      yzaehlen = yzaehlen + 2;
      poskerzex = Flammen[xzaehlen];
      poskerzey = Flammen[yzaehlen];
      tft.fillRect(poskerzex, poskerzey, 3, 50, WHITE);
      tft.drawRect(poskerzex - 1, poskerzey - 1, 5, 52, DARKGREY);
      nachmalzahlen = nachmalzahlen + 1;
    }
    if (zahl == 0) {
      delay(2000);
      zahl = 1;
      Happybirthday();
    }
  }
}
void kerzendef(){
  kerzenzahlen = 1;
  xschreiben = 0;
  yschreiben = 1;
  tft.setTextSize(2);
  tft.setTextColor(YELLOW);
  tft.setCursor(50, 280);
  tft.println("Bitte Kerzen");
  tft.setCursor(75, 300);
  tft.println("ausblasen");
  while (kerzenzahlen < 51) {
    poskerzex = random(2, 235);
    poskerzey = random(5, 230);


    kerzenmalen();
    kerzenzahlen = kerzenzahlen + 1;
  }
  kerzenzahlen = 1;
  xzaehlen = -2;
    yzaehlen = -1;
}
void kerzenmalen() {
  //////////////////////////////////////////////////////////////Kerze///////////////////////////////////////////////////////
  tft.fillRect(poskerzex, poskerzey, 3, 50, WHITE);
  tft.drawRect(poskerzex - 1, poskerzey - 1, 5, 52, DARKGREY);
  /////////////////////////////////////////////////////////////////Flamme////////////////////////////////////////////////////
  tft.fillRoundRect(poskerzex-2, poskerzey-11, 6, 10,2,YELLOW);
  tft.fillCircle(poskerzex + 1, poskerzey - 4, 3, ORANGE);
  tft.fillCircle(poskerzex + 1, poskerzey - 9, 2, RED);

  /////////////////////////////////////////////////////////////Matrix////////////////////////////////////////////////////////
  Flammen[xschreiben] = poskerzex;
  xschreiben = xschreiben + 2;
  Flammen[yschreiben] = poskerzey;
  yschreiben = yschreiben + 2;

}
void flackern(){
  poskerzex = Flammen[xzaehlen];
      poskerzey = Flammen[yzaehlen];
      
   tft.fillRoundRect(poskerzex-2, poskerzey-11, 6, 10,2,BLACK);
  tft.fillRoundRect(poskerzex-3, poskerzey-11, 6, 10,2,YELLOW);
  tft.fillCircle(poskerzex + 1, poskerzey - 4, 3, ORANGE);
  tft.fillCircle(poskerzex + 1, poskerzey - 9, 2, RED);
  tft.fillRoundRect(poskerzex-3, poskerzey-11, 6, 10,2,BLACK);
   tft.fillRoundRect(poskerzex-2, poskerzey-11, 6, 10,2,YELLOW);
   tft.fillCircle(poskerzex + 1, poskerzey - 4, 3, ORANGE);
  tft.fillCircle(poskerzex + 1, poskerzey - 9, 2, RED);
  
   xzaehlen = xzaehlen + 2;
      yzaehlen = yzaehlen + 2;
      if(xzaehlen>50){
        xzaehlen = -2;
    yzaehlen = -1;
      }
}
void kerzenreihe(){
  poskerzey = 230;
  poskerzex = -10;
  kerzenzahlen = 0;
  while(kerzenzahlen <10){
    poskerzex = poskerzex +23;
  //////////////////////////////////////////////////////////////Kerze///////////////////////////////////////////////////////
  tft.fillRect(poskerzex, poskerzey, 5, 50, WHITE);
  tft.drawRect(poskerzex - 1, poskerzey - 1, 7, 52, DARKGREY);
  /////////////////////////////////////////////////////////////////Flamme////////////////////////////////////////////////////
  tft.fillRoundRect(poskerzex-2, poskerzey-11, 8, 10,2,YELLOW);
  tft.fillCircle(poskerzex + 1, poskerzey - 4, 4, ORANGE);
  tft.fillCircle(poskerzex + 1, poskerzey - 9, 3, RED);
  kerzenzahlen = kerzenzahlen +1;
  }
}
void Happybirthday() {

  tft.fillScreen(BLACK);
  delay(100);
  tft.setCursor(20, 30);
  tft.setTextSize(3);
  tft.println("Lieber Uwe,");
  tft.setCursor(10, 60);
  tft.setTextSize(2);
  tft.print("wir w");
  tft.print(char(129));
  tft.print("nschen Dir");
  tft.setTextColor(CYAN);
  tft.setTextSize(4);
  tft.setCursor(0, 130);
  tft.println("Alles Gute");
  tft.setTextSize(2);
  tft.setCursor(10, 170);
  tft.println( "zum 50. Geburtstag");
  kerzenreihe();
  tft.setTextColor(WHITE);
  tft.setTextSize(2);
  tft.setCursor(30,300);
  tft.print("Zur");
  tft.print(char(129));
  tft.print("ck: dr");
  tft.print(char(129));
  tft.print("cken");
  while(blasen > 600){
    digitalWrite(13, HIGH);
  TSPoint p = ts.getPoint();
  digitalWrite(13, LOW);

  // if sharing pins, you'll need to fix the directions of the touchscreen pins
  //pinMode(XP, OUTPUT);
  pinMode(XM, OUTPUT);
  pinMode(YP, OUTPUT);
  //pinMode(YM, OUTPUT);
    if (p.z > MINPRESSURE && p.z < MAXPRESSURE) {
      zahl =0;
      tft.fillScreen(BLACK);
      delay(200);
      blasen = 1;
      kerzendef();
    }
  }
}


